Subject: Re: [tcpm] [tsvwg] draft-ietf-tcpm-rfc8312bis-04: flipped exponents in the AVG_W_cubic formulas?

From: Bob Briscoe <[email-masked]>
Date: Tue, 7 Sep 2021 14:13:11 +0100

Lars, (and switching again to tcpm from tsvwg)

On 03/09/2021 19:53, Lars Eggert wrote:
> This was my mistake when doing the formula - THANK YOU for finding that!

[BB] A nit (I wouldn't have bothered saying this if the draft hadn't 
just become a candidate for a major drains-up following Markku's review).

FWIW, I prefer the style of formulae as they were in RFC8312.
I'm not going to insist, but trying to lay out formulae like ASCII art 
didn't work for me. Sorry, I know it must have taken some time to lay it 
all out, which might not have been in vain if I'm overruled. Also, I 
don't think I've seen any other RFCs attempt to do this.

Showing formulae with superscripts and subscripts and fractions on 
multiple lines sometimes made it harder not easier to visualize the 
formulae (for me).
But the main disadvantage is that it's not easily machine-readable. So 
it cannot be accurately translated into different formats and it's more 
ambiguous. It also creates problems when quoted in emails if it gets 
quoted in a variable width font (which just happened to me, hence this 
email).

Admittedly, using ^ and _ for superscripts and subscripts is not 
brilliant either. Nor is using () / () for fractions. Nor sqrt() etc. 
But at least it's what people are used to in code, and in mark-up 
languages and LaTeX.

See also RFC1003, RFC1019, draft-ash-alt-formats, etc.

Bob

PS. I'm guilty of hypocrisy in that an RFC I co-authored shows complex 
fractions as ASCII art, altho the numerator and denominator are in 
C-code style maths. See 
https://datatracker.ietf.org/doc/html/rfc7893#page-9
FWIW, I didn't write the parts with the formulae in.

>
> -- 
> Sent from a mobile device; please excuse typos.
>
>> On Sep 3, 2021, at 21:39, Lisong Xu <[email-masked]> wrote:
>>
>> 
>> Thank you very much, Neal, for finding this important typo. You are 
>> right that the exponent should be 3/4 instead of 4/3 for Figures 5, 
>> 6, and 7.
>>
>> Thanks
>> Lisong
>>
>> ------------------------------------------------------------------------
>> *From:* Neal Cardwell <[email-masked]>
>> *Sent:* Friday, September 3, 2021 1:01 PM
>> *To:* [email-masked] 
>> <[email-masked]>
>> *Cc:* tsvwg IETF list <[email-masked]>
>> *Subject:* draft-ietf-tcpm-rfc8312bis-04: flipped exponents in the 
>> AVG_W_cubic formulas?
>> Non-NU Email
>> ------------------------------------------------------------------------
>> Dear rfc8312bis authors,
>>
>> First, thanks for all your work on rfc8312bis!
>>
>> Next: I was about to use the AVG_W_cubic formulas in the rfc8312bis 
>> text, and noticed what appears to be a discrepancy between the 
>> rfc8312bis AVG_W_cubic formulas and the AVG_W_cubic formulas in both:
>>
>> (1) the RFC 8312: *MailScanner has detected a possible fraud attempt 
>> from "urldefense.com" claiming to be* 
>> https://datatracker.ietf.org/doc/html/rfc8312#section-5 
>> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc8312*section-5__;Iw!!PvXuogZ4sRB2p-tU!XrfKDCjwS6huhjdCHYDYUlgBpZ4GD0kXzOG363gPaoXUS9UNHjoMt0_BK0Ny1Q$>
>> (2) the CUBIC paper: *MailScanner has detected a possible fraud 
>> attempt from "urldefense.com" claiming to be* 
>> https://dl.acm.org/doi/10.1145/1400097.1400105 
>> <https://urldefense.com/v3/__https://dl.acm.org/doi/10.1145/1400097.1400105__;!!PvXuogZ4sRB2p-tU!XrfKDCjwS6huhjdCHYDYUlgBpZ4GD0kXzOG363gPaoXUS9UNHjoMt0_wZ47m5g$>
>>
>> In both (1) and (2) the formulas have RTT and p taken to the power of 
>> 3/4; for example:
>>
>>     With beta_cubic set to 0.7, the above formula is reduced to:
>>         AVG_W_cubic = (C*3.7/1.2)^0.25 * (RTT^0.75) / (p^0.75) (Eq. 6)
>>
>> By contrast, the rfc8312bis text, in Figures 5, 6, and 7, has RTT and 
>> p taken to the power of 4/3:
>>
>>                                    ________________      ____
>>                                   /C * (3 + β     )   3 /   4
>>                              4   /           cubic    |/ RTT
>>                 AVG_W      = |  /  ---------------- * -------
>>                      cubic   | /   4 * (1 - β     )       __
>>                              |/              cubic     3 / 4
>>                                                        |/ p
>>
>>                                    Figure 5
>> ----
>>                                                    ____
>>                                       _______   3 /   4
>>                                   4  /C * 3.7   |/ RTT
>>                      AVG_W      = | / ------- * -------
>>                           cubic   |/    1.2         __
>>                                                  3 / 4
>>                                                  |/ p
>>
>>                                    Figure 6
>> ----
>> 3 / 4
>>                                              |/ RTT
>>                         AVG_W      = 1.054 * -------
>>                              cubic               __
>>                                               3 / 4
>>                                               |/ p
>>
>>                                    Figure 7
>> That is, it appears there are typos in the formulas in rfc8312bis 
>> that systematically swapped the 3 and 4 in the exponents for RTT and 
>> p, yielding exponents of 4/3 instead of the  3/4 value from the 
>> original paper and RFC 8312.
>>
>> best regards,
>> neal
>>

-- 
________________________________________________________________
Bob Briscoe                               http://bobbriscoe.net/

---

From: Lars Eggert <[email-masked]>
Date: Tue, 7 Sep 2021 17:02:15 +0300

Hi,

On 2021-9-7, at 16:13, Bob Briscoe <[email-masked]> wrote:
> [BB] A nit (I wouldn't have bothered saying this if the draft hadn't just become a candidate for a major drains-up following Markku's review).

what gave you that impression? :-)

> FWIW, I prefer the style of formulae as they were in RFC8312.

Noted. So far, I've heard some preference for the change, but that can of course change. I just wished people wouldn't wait until after WGLC to actually send comments :-/

Thanks,
Lars

---

From: "Rodney W. Grimes" <[email-masked]>
Date: Tue, 7 Sep 2021 09:53:12 -0700 (PDT)

Hello Lars, Bob, list(s),
	comments inline [RWG],
Regards
Rod

> Noted. So far, I've heard some preference for the change, but that can of course change.

 [RWG]  Though ascii art is good for conveying bits in bytes of packets,
it is absolutely horrid for trying to exactly communicate a formula.  I
support Bob's position that this would be better expressed as code snippits.

> I just wished people wouldn't wait until after WGLC to actually send comments :-/

 [RWG] This seems to indicate there is a breakdown in process.

> _______________________________________________
> tcpm mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/tcpm

-- 
Rod Grimes                                                 [email-masked]

---

From: Lars Eggert <[email-masked]>
Date: Wed, 8 Sep 2021 10:02:00 +0300

Hi,

> support Bob's position that this would be better expressed as code snippits.

would you (and Bob) take a look at the HTML rendering of the document, i.e., https://www.ietf.org/archive/id/draft-ietf-tcpm-rfc8312bis-04.html?

Thanks,
Lars

---

From: "Rodney W. Grimes" <[email-masked]>
Date: Wed, 8 Sep 2021 07:07:33 -0700 (PDT)

Hello Lars,

> would you (and Bob) take a look at the HTML rendering of the document, i.e., https://www.ietf.org/archive/id/draft-ietf-tcpm-rfc8312bis-04.html?

I have.

BUTT when and if the IETF desides that HTML is the standard form
of the drafts then and only then should be acceptable to have
the then non-standard form (ASCII) to convey information poorly.

> Lars

Regards,
Rod

---

From: tom petch <[email-masked]>
Date: Wed, 8 Sep 2021 15:36:46 +0000

From: tcpm <[email-masked]> on behalf of Rodney W. Grimes <[email-masked]>
Sent: 08 September 2021 15:07

Hello Lars,

I have.

<tp>
A minor thought.  The aim is, or should be. to produce an RFC and what is best for an I-D may not be best for an RFC.

Major thought,  Text/ ASCII is not the standard form.  The canonical form is XML, the primary rendered format is HTML.  (PDF has been used in the past for mathematical formulae when ASCII was inadequate but I do not see the case for that anymore).

Tom Petch

Regards,
Rod

---

From: Bob Briscoe <[email-masked]>
Date: Wed, 15 Sep 2021 13:19:06 +0100

Lars,

>> would you (and Bob) take a look at the HTML rendering of the document, i.e., https://www.ietf.org/archive/id/draft-ietf-tcpm-rfc8312bis-04.html?

[BB] Beautiful :)
I was looking at the htmlized ASCII rather than the HTML.

Now I look at the XML, I see you've tried to emulate the .svg's with the 
ascii-art alternatives.
I think I would have not bothered, and instead just pasted the original 
equations from RFC8312 into the ascii-art alternatives. But as I said, 
that's my personal preference (and at least Rod agrees). It would also 
allow a good diff between the ASCII versions to see if any of the maths 
had changed (which BTW would have highlighted the flip of the exponents).

No great biggie for me. Especially now I know that I (and others) have 
the HTML.

However, I don't seem to be able to copy/paste the svg's at all from the 
HTML, which is what I was originally trying to do with the ASCII art, 
which was what led to my whinge.

Bob